#!/bin/bash
#
# Last update: 2024.7.18

Remote_Server='XXX'

# RemoteBackup Function

RemoteBackup(){

for account in `whmapi1 --output=jsonpretty get_disk_usage | jq -r '.data.accounts[] | .user'`
do

# 無加上 --del 主要是避免異機帳號備份內 homedir/public_html 被刪除，後續又要rsync一次，浪費時間
ssh root@$Remote_Server "mkdir -p /mnt/account/$account/"

done


if [ ! -d "/backup/account/" ]; then
    mkdir -p "/backup/account"
fi


# 使用5線程執行本機備份 (-P 後面數值可自行調整線程數量)
whmapi1 --output=jsonpretty get_disk_usage | jq -r '.data.accounts[] | .user' | xargs -I {} -P 5 -n 1 /usr/local/cpanel/bin/pkgacct --incremental {} /backup/account

# 使用8線程執行rsync備份 (-P 後面數值可自行調整線程數量)
whmapi1 --output=jsonpretty get_disk_usage | jq -r '.data.accounts[] | .user' | xargs -I {} -P 8 -n 1 rsync -av --del --ignore-errors /backup/account/cpmove-{}/ root@$Remote_Server:/mnt/account/{}/

}

# Run RemoteBackup

RemoteBackup

